summaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
author abooksigun2020-02-19 11:23:24 +0100
committer Willy Sudiarto Raharjo2020-02-19 11:23:24 +0100
commitb48d647b2bd096a81612411bba6ac8e77e0644cd (patch)
tree51a23be0e9263d807a03e7fbaf04a82bdb801aec
parent595f654c76e2c8ed89ddf1dbd2ea370b72905623 (diff)
downloadslackbuilds-b48d647b2bd096a81612411bba6ac8e77e0644cd.tar.gz
development/urn: Added (Lisp Dialect).
Signed-off-by: Willy Sudiarto Raharjo <willysr@slackbuilds.org>
-rw-r--r--development/urn/README21
-rw-r--r--development/urn/slack-desc19
-rw-r--r--development/urn/urn.SlackBuild99
-rw-r--r--development/urn/urn.info10
4 files changed, 149 insertions, 0 deletions
diff --git a/development/urn/README b/development/urn/README
new file mode 100644
index 0000000000..b731adba10
--- /dev/null
+++ b/development/urn/README
@@ -0,0 +1,21 @@
+Urn is a new language developed by SquidDev, and demhydraz.
+Urn is a Lisp dialect with a focus on minimalism which compiles to Lua.
+
+What?
+* A minimal¹ Lisp implementation, with full support for compile time code execution and macros.
+* Support for Lua 5.1, 5.2 and 5.3. Should also work with LuaJIT.
+* Lisp-1 scoping rules (functions and data share the same namespace).
+* Influenced by a whole range of Lisp implementations, including Common Lisp and Clojure.
+* Produces standalone, optimised Lua files: no dependencies on a standard library.
+
+¹: Minimalism is an implementation detail.
+
+Default urn works with lua 5.1
+you can set "URN_LUAVER" environment variable to change the lua version
+example:
+URN_LUAVER=5.3 for lua 5.3
+URN_LUAVER=jit for luajit
+
+Optional Dependency:
+* lua-readline
+For history completion
diff --git a/development/urn/slack-desc b/development/urn/slack-desc
new file mode 100644
index 0000000000..8e65b70203
--- /dev/null
+++ b/development/urn/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description.
+# Line up the first '|' above the ':' following the base package name, and
+# the '|' on the right side marks the last column you can put a character in.
+# You must make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':' except on otherwise blank lines.
+
+ |-----handy-ruler------------------------------------------------------|
+urn: urn (Lisp dialect that compiles to Lua.)
+urn:
+urn: Urn is a new language developed by SquidDev, and demhydraz.
+urn: Urn is a Lisp dialect with a focus on minimalism
+urn: which compiles to Lua.
+urn:
+urn: Homepage: https://urn-lang.com
+urn:
+urn:
+urn:
+urn:
diff --git a/development/urn/urn.SlackBuild b/development/urn/urn.SlackBuild
new file mode 100644
index 0000000000..e9c5d11694
--- /dev/null
+++ b/development/urn/urn.SlackBuild
@@ -0,0 +1,99 @@
+#!/bin/sh
+
+# Slackware build script for urn
+# Copyright 2020 abooksigun <abooksigun09@gmail.com>
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ''AS IS'' AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+PRGNAM=urn
+VERSION=${VERSION:-0.7.2}
+BUILD=${BUILD:-1}
+TAG=${TAG:-_SBo}
+
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) ARCH=i486 ;;
+ arm*) ARCH=arm ;;
+ *) ARCH=$( uname -m ) ;;
+ esac
+fi
+
+CWD=$(pwd)
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+if [ "$ARCH" = "i486" ]; then
+ SLKCFLAGS="-O2 -march=i486 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="-O2 -march=i686 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+else
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+fi
+
+set -e
+
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $TMP
+rm -rf $PRGNAM-v$VERSION
+tar xvf $CWD/$PRGNAM-v$VERSION.tar.gz
+cd $PRGNAM-v$VERSION
+chown -R root:root .
+find -L . \
+ \( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 -o -perm 511 \) \
+ -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 600 -o -perm 444 -o -perm 440 -o -perm 400 \) \
+ -exec chmod 644 {} \;
+
+make all
+make all
+
+install -m 755 -d $PKG/usr/bin
+install -m 755 -d $PKG/usr/share/$PRGNAM
+
+find bin lib plugins -type d -exec install -dm 755 $PKG/usr/share/$PRGNAM/{} \;
+find lib plugins -type f -exec install -m 644 {} $PKG/usr/share/$PRGNAM/{} \;
+find bin -type f -exec install -m 755 {} $PKG/usr/share/$PRGNAM/{} \;
+
+cat << EOF > $PKG/usr/bin/urn
+#!/usr/bin/env sh
+exec lua\$URN_LUAVER /usr/share/urn/bin/urn.lua \$@
+EOF
+chmod 755 $PKG/usr/bin/urn
+
+find $PKG -print0 | xargs -0 file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cp -a LICENCE README.md $PKG/usr/doc/$PRGNAM-$VERSION
+
+cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.${PKGTYPE:-tgz}
diff --git a/development/urn/urn.info b/development/urn/urn.info
new file mode 100644
index 0000000000..c88fea91a8
--- /dev/null
+++ b/development/urn/urn.info
@@ -0,0 +1,10 @@
+PRGNAM="urn"
+VERSION="0.7.2"
+HOMEPAGE="https://urn-lang.com/"
+DOWNLOAD="https://gitlab.com/urn/urn/-/archive/v0.7.2/urn-v0.7.2.tar.gz"
+MD5SUM="190761aa2e57152ac2a1e5466462e02b"
+DOWNLOAD_x86_64=""
+MD5SUM_x86_64=""
+REQUIRES="lua"
+MAINTAINER="abooksigun"
+EMAIL="abooksigun09@gmail.com"